
package cn.suwell.web;

import java.io.File;

import java.io.IOException;
import java.io.Writer;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.io.FileUtils;

/**
 * ״ʵļԶ̴洢ֻṩһdemo
 * ûԽҲʵ֣עеTODOǩ
 * email ofd-support@suwell.cnqq:54464170
 * @author Lixin
 */
public class UploadServlet extends HttpServlet
{
    private static final long serialVersionUID = -1300586362967986801L;
    //ϴļĴС4G
    private static final long MAX_FILE_SIZE = 4L * 1024 * 1024 * 1024;
    //С1M
    private static final int  BUFFER_SIZE = 1 *1024 * 1024;
    public static final DateFormat FORMAT = new SimpleDateFormat("yyyy-MM-dd");

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        this.doPost(request, response);
    }

    protected void doPost(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        //-------------------ϴļ浽еfilesļbegin------------------
        Writer writer = response.getWriter();
        try
        {
            boolean isMultipart = ServletFileUpload.isMultipartContent(request);
            if (!isMultipart)return;

            DiskFileItemFactory factory = new DiskFileItemFactory();
            factory.setSizeThreshold(BUFFER_SIZE);// max memory cache
            // factory.setRepository(yourTempDirectory);
            ServletFileUpload upload = new ServletFileUpload(factory);
            upload.setFileSizeMax(MAX_FILE_SIZE);
            String charset = request.getCharacterEncoding();
            if (charset == null)
                charset = "UTF-8";
            upload.setHeaderEncoding(charset);
            List<FileItem> items = upload.parseRequest(request);
            if ((items == null) || items.isEmpty())
            {
                System.out.println("ûκļϴ!");
                return;
            }
            FileItem fi = null;
            for (FileItem item : items)
            {
                if (!item.isFormField())
                {
                    fi = item;
                    break;
                }
            }
            if (fi != null)
            {
                String name = fi.getName();
                String dir = getServletContext().getRealPath("/files");
                File file = new File(dir + File.separator + name);

                System.out.println("ϴļ"+ name + ".ofd浽λ" + dir );
                if (fi instanceof DiskFileItem)
                {// Կٴ
                    DiskFileItem dfi = (DiskFileItem)fi;
                    if (dfi.isInMemory())
                    {
                        byte[] b = dfi.get();
                        FileUtils.writeByteArrayToFile(file, b);
                    }
                    else
                    {
                        File in = dfi.getStoreLocation();
                        FileUtils.copyFile(in, file);
                    }
                }
                else
                {// ĬϷʽ
                    fi.write(file);
                }
                file.setLastModified(System.currentTimeMillis());
                writer.write("ļ" + name + "ϴɹ");
                writer.flush();
            }
            else
                System.out.println("commons-fileupload- 1.3.1.jarδκϴļ");
        }
        catch(Exception e)
        {
            System.out.println("commons-fileupload- 1.3.1.jarдFileItem.write()쳣");
            response.sendError(500, e.getMessage());
        }
        //--------------------ϴļ浽еfilesļend------------------
        //TODO ʵĿʵʩ ,beginend߼ Ӧʵ֡
    }
}
